;;; -*- Mode: Lisp; Package: STELLA; Syntax: COMMON-LISP; Base: 10 -*-

#|--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2002      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------|#

(CL:IN-PACKAGE "STELLA")

;;; Auxiliary variables:

(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-FOREACH NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-ITEM NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-IN NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-CAST NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-CONS NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-OF NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-DO NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-INSERT-AT NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-FIRST NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-SECOND NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-AM NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-PM NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-NOON NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-MIDN NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-MONTH NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-WEEKDAY NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-AM-PM NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-NOON-MIDN NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-ZONE NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-SPECIAL NULL)
(CL:DEFVAR KWD-DATE-TIME-PARSER-LETTER NULL)
(CL:DEFVAR KWD-DATE-TIME-PARSER-DIGIT NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-TIME-DIVIDER NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-DATE-DIVIDER NULL)
(CL:DEFVAR SGT-DATE-TIME-PARSER-STELLA-CONS NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-SECONDP NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-MINUTE NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-HOUR NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-DAY NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-YEAR NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-STARTUP-DATE-TIME-PARSER NULL)
(CL:DEFVAR SYM-DATE-TIME-PARSER-STELLA-METHOD-STARTUP-CLASSNAME NULL)

;;; Forward declarations:

(CL:DECLAIM
 (CL:SPECIAL *STELLA-MODULE* *MODULE* NULL-CHARACTER *CHARACTER-TYPE-TABLE*
  TRUE-WRAPPER FALSE-WRAPPER))

;;; (DEFCONSTANT WHITESPACE-CHARS ...)

(CL:DEFVAR WHITESPACE-CHARS NULL)

;;; (DEFCONSTANT TIME-DIVIDERS ...)

(CL:DEFVAR TIME-DIVIDERS NULL)

;;; (DEFCONSTANT DATE-DIVIDERS ...)

(CL:DEFVAR DATE-DIVIDERS NULL)

;;; (DEFSPECIAL *ERROR-ON-MISMATCH* ...)

(CL:DEFVAR *ERROR-ON-MISMATCH* FALSE
  "If TRUE, an error will be signalled if parse-date-time is unable
   to determine the time/date format of the string.")

;;; (DEFMACRO HASHLIST ...)

(CL:DEFUN HASHLIST (LIST TABLE)
  (CL:RETURN-FROM HASHLIST
   (LIST* SYM-DATE-TIME-PARSER-STELLA-FOREACH SYM-DATE-TIME-PARSER-STELLA-ITEM
    SYM-DATE-TIME-PARSER-STELLA-IN
    (LIST* SYM-DATE-TIME-PARSER-STELLA-CAST LIST
     (CONS
      (LIST* SYM-DATE-TIME-PARSER-STELLA-CONS SYM-DATE-TIME-PARSER-STELLA-OF
       SYM-DATE-TIME-PARSER-STELLA-CONS NIL)
      NIL))
    SYM-DATE-TIME-PARSER-STELLA-DO
    (LIST* SYM-DATE-TIME-PARSER-STELLA-INSERT-AT TABLE
     (LIST*
      (LIST* SYM-DATE-TIME-PARSER-STELLA-FIRST SYM-DATE-TIME-PARSER-STELLA-ITEM
       NIL)
      (LIST* SYM-DATE-TIME-PARSER-STELLA-SECOND
       SYM-DATE-TIME-PARSER-STELLA-ITEM NIL)
      NIL))
    NIL)))

;;; (DEFSPECIAL *WEEKDAY-STRINGS* ...)

(CL:DEFVAR *WEEKDAY-STRINGS* NULL)

;;; (DEFSPECIAL *MONTH-STRINGS* ...)

(CL:DEFVAR *MONTH-STRINGS* NULL)

;;; (DEFSPECIAL *ZONE-STRINGS* ...)

(CL:DEFVAR *ZONE-STRINGS* NULL)

;;; (DEFSPECIAL *SPECIAL-STRINGS* ...)

(CL:DEFVAR *SPECIAL-STRINGS* NULL)

;;; (DEFSPECIAL *SPECIAL-SYMBOLS* ...)

(CL:DEFVAR *SPECIAL-SYMBOLS* NULL)

;;; (DEFSPECIAL *DATE-TIME-PATTERNS* ...)

(CL:DEFVAR *DATE-TIME-PATTERNS* NULL)

;;; (DEFUN YESTERDAY ...)

(CL:DEFUN YESTERDAY (PARSED-VALUES)
  (TODAY PARSED-VALUES)
  (CL:LET*
   ((JD
     (COMPUTE-JULIAN-DAY (%DATE-TIME-YEAR PARSED-VALUES)
      (%DATE-TIME-MONTH PARSED-VALUES) (%DATE-TIME-DAY PARSED-VALUES))))
   (CL:DECLARE (CL:TYPE CL:FIXNUM JD))
   (CL:LET*
    ((YEAR NULL-INTEGER) (MONTH NULL-INTEGER) (DAY NULL-INTEGER) (DOW NULL))
    (CL:DECLARE (CL:TYPE CL:FIXNUM YEAR MONTH DAY))
    (CL:MULTIPLE-VALUE-SETQ (YEAR MONTH DAY DOW)
     (COMPUTE-CALENDAR-DATE (CL:1- JD)))
    (CL:SETF (%DATE-TIME-DAY PARSED-VALUES) DAY)
    (CL:SETF (%DATE-TIME-MONTH PARSED-VALUES) MONTH)
    (CL:SETF (%DATE-TIME-YEAR PARSED-VALUES) YEAR)
    (CL:SETF (%DATE-TIME-DOW PARSED-VALUES) DOW)))
  :VOID)

;;; (DEFUN TODAY ...)

(CL:DEFUN TODAY (PARSED-VALUES)
  (CL:LET*
   ((YEAR NULL-INTEGER) (MONTH NULL-INTEGER) (DAY NULL-INTEGER) (DOW NULL))
   (CL:DECLARE (CL:TYPE CL:FIXNUM YEAR MONTH DAY))
   (CL:MULTIPLE-VALUE-SETQ (YEAR MONTH DAY DOW)
    (GET-CALENDAR-DATE (MAKE-CURRENT-DATE-TIME)
     (%DATE-TIME-ZONE PARSED-VALUES)))
   (CL:SETF (%DATE-TIME-DAY PARSED-VALUES) DAY)
   (CL:SETF (%DATE-TIME-MONTH PARSED-VALUES) MONTH)
   (CL:SETF (%DATE-TIME-YEAR PARSED-VALUES) YEAR)
   (CL:SETF (%DATE-TIME-DOW PARSED-VALUES) DOW))
  :VOID)

;;; (DEFUN TOMORROW ...)

(CL:DEFUN TOMORROW (PARSED-VALUES)
  (TODAY PARSED-VALUES)
  (CL:LET*
   ((JD
     (COMPUTE-JULIAN-DAY (%DATE-TIME-YEAR PARSED-VALUES)
      (%DATE-TIME-MONTH PARSED-VALUES) (%DATE-TIME-DAY PARSED-VALUES))))
   (CL:DECLARE (CL:TYPE CL:FIXNUM JD))
   (CL:LET*
    ((YEAR NULL-INTEGER) (MONTH NULL-INTEGER) (DAY NULL-INTEGER) (DOW NULL))
    (CL:DECLARE (CL:TYPE CL:FIXNUM YEAR MONTH DAY))
    (CL:MULTIPLE-VALUE-SETQ (YEAR MONTH DAY DOW)
     (COMPUTE-CALENDAR-DATE (CL:1+ JD)))
    (CL:SETF (%DATE-TIME-DAY PARSED-VALUES) DAY)
    (CL:SETF (%DATE-TIME-MONTH PARSED-VALUES) MONTH)
    (CL:SETF (%DATE-TIME-YEAR PARSED-VALUES) YEAR)
    (CL:SETF (%DATE-TIME-DOW PARSED-VALUES) DOW)))
  :VOID)

;;; (DEFUN NOW ...)

(CL:DEFUN NOW (PARSED-VALUES)
  (CL:LET*
   ((HOUR NULL-INTEGER) (MINUTE NULL-INTEGER) (SECOND NULL-INTEGER)
    (MILLIS NULL-INTEGER))
   (CL:DECLARE (CL:TYPE CL:FIXNUM HOUR MINUTE SECOND MILLIS))
   (CL:MULTIPLE-VALUE-SETQ (HOUR MINUTE SECOND MILLIS)
    (GET-TIME (MAKE-CURRENT-DATE-TIME) (%DATE-TIME-ZONE PARSED-VALUES)))
   (CL:SETF (%DATE-TIME-MILLIS PARSED-VALUES) MILLIS)
   (CL:SETF (%DATE-TIME-SECOND PARSED-VALUES) SECOND)
   (CL:SETF (%DATE-TIME-MINUTE PARSED-VALUES) MINUTE)
   (CL:SETF (%DATE-TIME-HOUR PARSED-VALUES) HOUR))
  :VOID)

;;; (DEFUN (AM-PM SYMBOL) ...)

(CL:DEFUN AM-PM (STRING)
  (CL:COND
   ((SUBTYPE-OF-STRING? (SAFE-PRIMARY-TYPE STRING))
    (CL:PROGN
     (CL:COND
      ((STRING-EQL? (%WRAPPER-VALUE STRING) "am")
       (CL:RETURN-FROM AM-PM SYM-DATE-TIME-PARSER-STELLA-AM))
      ((STRING-EQL? (%WRAPPER-VALUE STRING) "pm")
       (CL:RETURN-FROM AM-PM SYM-DATE-TIME-PARSER-STELLA-PM))
      (CL:T (CL:RETURN-FROM AM-PM NULL)))))
   (CL:T (CL:RETURN-FROM AM-PM NULL))))

;;; (DEFUN (NOON-MIDN SYMBOL) ...)

(CL:DEFUN NOON-MIDN (STRING)
  (CL:COND
   ((SUBTYPE-OF-STRING? (SAFE-PRIMARY-TYPE STRING))
    (CL:PROGN
     (CL:COND
      ((STRING-EQL? (%WRAPPER-VALUE STRING) "noon")
       (CL:RETURN-FROM NOON-MIDN SYM-DATE-TIME-PARSER-STELLA-NOON))
      ((STRING-EQL? (%WRAPPER-VALUE STRING) "midnight")
       (CL:RETURN-FROM NOON-MIDN SYM-DATE-TIME-PARSER-STELLA-MIDN))
      (CL:T (CL:RETURN-FROM NOON-MIDN NULL)))))
   (CL:T (CL:RETURN-FROM NOON-MIDN NULL))))

;;; (DEFUN (WEEKDAY KEYWORD) ...)

(CL:DEFUN WEEKDAY (THING)
  (CL:COND
   ((SUBTYPE-OF-STRING? (SAFE-PRIMARY-TYPE THING))
    (CL:PROGN
     (CL:RETURN-FROM WEEKDAY
      (LOOKUP *WEEKDAY-STRINGS* (%WRAPPER-VALUE THING)))))
   (CL:T (CL:RETURN-FROM WEEKDAY NULL))))

;;; (DEFUN (MONTH INTEGER-WRAPPER) ...)

(CL:DEFUN MONTH (THING)
  (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE THING)))
   (CL:COND
    ((SUBTYPE-OF-STRING? TEST-VALUE-000)
     (CL:PROGN
      (CL:LET* ((MONTH-NUMBER (LOOKUP *MONTH-STRINGS* (%WRAPPER-VALUE THING))))
       (CL:DECLARE (CL:TYPE CL:FIXNUM MONTH-NUMBER))
       (CL:IF (DEFINED? MONTH-NUMBER)
        (CL:RETURN-FROM MONTH (WRAP-INTEGER MONTH-NUMBER))
        (CL:RETURN-FROM MONTH NULL)))))
    ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
     (CL:PROGN
      (CL:IF
       (CL:AND (CL:<= 1 (%WRAPPER-VALUE THING))
        (CL:<= (%WRAPPER-VALUE THING) 12))
       (CL:RETURN-FROM MONTH THING) (CL:RETURN-FROM MONTH NULL))))
    (CL:T (CL:RETURN-FROM MONTH NULL)))))

;;; (DEFUN (ZONE FLOAT-WRAPPER) ...)

(CL:DEFUN ZONE (THING)
  (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE THING)))
   (CL:COND
    ((SUBTYPE-OF-STRING? TEST-VALUE-000)
     (CL:PROGN
      (CL:LET* ((ZONE-NUMBER (LOOKUP *ZONE-STRINGS* (%WRAPPER-VALUE THING))))
       (CL:IF (CL:NOT (CL:EQ ZONE-NUMBER NULL))
        (CL:RETURN-FROM ZONE ZONE-NUMBER) (CL:RETURN-FROM ZONE NULL)))))
    ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
     (CL:PROGN
      (CL:IF
       (CL:AND (CL:<= -12.0d0 (%WRAPPER-VALUE THING))
        (CL:<= (%WRAPPER-VALUE THING) 14.0d0))
       (CL:RETURN-FROM ZONE THING) (CL:RETURN-FROM ZONE NULL))))
    ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
     (CL:PROGN
      (CL:LET* ((OFFSET (%WRAPPER-VALUE THING)))
       (CL:DECLARE (CL:TYPE CL:FIXNUM OFFSET))
       (CL:COND
        ((CL:AND (CL:<= -12 OFFSET) (CL:<= OFFSET 14))
         (CL:RETURN-FROM ZONE (WRAP-FLOAT (CL:FLOAT OFFSET 0.0d0))))
        ((CL:AND (CL:<= -1200 OFFSET) (CL:<= OFFSET 1400))
         (CL:RETURN-FROM ZONE
          (WRAP-FLOAT
           (CL:+ (FLOOR (CL:/ OFFSET 100.0d0))
            (CL:/ (CL:THE CL:FIXNUM (CL:MOD OFFSET 100)) 60.0d0)))))
        (CL:T (CL:RETURN-FROM ZONE NULL))))))
    (CL:T (CL:RETURN-FROM ZONE NULL)))))

;;; (DEFUN (SPECIALP SYMBOL) ...)

(CL:DEFUN SPECIALP (STRING)
  (CL:COND
   ((SUBTYPE-OF-STRING? (SAFE-PRIMARY-TYPE STRING))
    (CL:PROGN
     (CL:RETURN-FROM SPECIALP
      (LOOKUP *SPECIAL-STRINGS* (%WRAPPER-VALUE STRING)))))
   (CL:T (CL:RETURN-FROM SPECIALP NULL))))

;;; (DEFUN (SECONDP BOOLEAN-WRAPPER) ...)

(CL:DEFUN SECONDP (NUMBER)
  (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE NUMBER)))
   (CL:COND
    ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
     (CL:PROGN
      (CL:RETURN-FROM SECONDP
       (CL:IF
        (CL:AND (CL:<= 0 (%WRAPPER-VALUE NUMBER))
         (CL:<= (%WRAPPER-VALUE NUMBER) 59))
        TRUE-WRAPPER FALSE-WRAPPER))))
    ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
     (CL:PROGN
      (CL:RETURN-FROM SECONDP
       (CL:IF
        (CL:AND (CL:<= 0.0d0 (%WRAPPER-VALUE NUMBER))
         (CL:< (%WRAPPER-VALUE NUMBER) 60.0d0))
        TRUE-WRAPPER FALSE-WRAPPER))))
    (CL:T (CL:RETURN-FROM SECONDP FALSE-WRAPPER)))))

;;; (DEFUN (MINUTE BOOLEAN-WRAPPER) ...)

(CL:DEFUN MINUTE (NUMBER)
  (CL:COND
   ((SUBTYPE-OF-INTEGER? (SAFE-PRIMARY-TYPE NUMBER))
    (CL:PROGN
     (CL:RETURN-FROM MINUTE
      (CL:IF
       (CL:AND (CL:<= 0 (%WRAPPER-VALUE NUMBER))
        (CL:<= (%WRAPPER-VALUE NUMBER) 59))
       TRUE-WRAPPER FALSE-WRAPPER))))
   (CL:T (CL:RETURN-FROM MINUTE FALSE-WRAPPER))))

;;; (DEFUN (HOUR BOOLEAN-WRAPPER) ...)

(CL:DEFUN HOUR (NUMBER)
  (CL:COND
   ((SUBTYPE-OF-INTEGER? (SAFE-PRIMARY-TYPE NUMBER))
    (CL:PROGN
     (CL:RETURN-FROM HOUR
      (CL:IF
       (CL:AND (CL:<= 0 (%WRAPPER-VALUE NUMBER))
        (CL:<= (%WRAPPER-VALUE NUMBER) 23))
       TRUE-WRAPPER FALSE-WRAPPER))))
   (CL:T (CL:RETURN-FROM HOUR FALSE-WRAPPER))))

;;; (DEFUN (DAY BOOLEAN-WRAPPER) ...)

(CL:DEFUN DAY (NUMBER)
  (CL:COND
   ((SUBTYPE-OF-INTEGER? (SAFE-PRIMARY-TYPE NUMBER))
    (CL:PROGN
     (CL:RETURN-FROM DAY
      (CL:IF
       (CL:AND (CL:<= 1 (%WRAPPER-VALUE NUMBER))
        (CL:<= (%WRAPPER-VALUE NUMBER) 31))
       TRUE-WRAPPER FALSE-WRAPPER))))
   (CL:T (CL:RETURN-FROM DAY FALSE-WRAPPER))))

;;; (DEFUN (YEAR BOOLEAN-WRAPPER) ...)

(CL:DEFUN YEAR (NUMBER)
  (CL:COND
   ((SUBTYPE-OF-INTEGER? (SAFE-PRIMARY-TYPE NUMBER))
    (CL:PROGN
     (CL:RETURN-FROM YEAR
      (CL:IF
       (CL:OR (CL:<= -4713 (%WRAPPER-VALUE NUMBER))
        (CL:<= (%WRAPPER-VALUE NUMBER) 5000))
       TRUE-WRAPPER FALSE-WRAPPER))))
   (CL:T (CL:RETURN-FROM YEAR FALSE-WRAPPER))))

;;; (DEFUN (TIME-DIVIDER BOOLEAN-WRAPPER) ...)

(CL:DEFUN TIME-DIVIDER (THECHARACTER)
  (CL:COND
   ((SUBTYPE-OF-CHARACTER? (SAFE-PRIMARY-TYPE THECHARACTER))
    (CL:PROGN
     (CL:RETURN-FROM TIME-DIVIDER
      (CL:IF (MEMBER? TIME-DIVIDERS THECHARACTER) TRUE-WRAPPER
       FALSE-WRAPPER))))
   (CL:T (CL:RETURN-FROM TIME-DIVIDER FALSE-WRAPPER))))

;;; (DEFUN (DATE-DIVIDER BOOLEAN-WRAPPER) ...)

(CL:DEFUN DATE-DIVIDER (THECHARACTER)
  (CL:COND
   ((SUBTYPE-OF-CHARACTER? (SAFE-PRIMARY-TYPE THECHARACTER))
    (CL:PROGN
     (CL:RETURN-FROM DATE-DIVIDER
      (CL:IF (MEMBER? DATE-DIVIDERS THECHARACTER) TRUE-WRAPPER
       FALSE-WRAPPER))))
   (CL:T (CL:RETURN-FROM DATE-DIVIDER FALSE-WRAPPER))))

;;; (DEFUN (MATCH-SUBSTRING CONS) ...)

(CL:DEFUN MATCH-SUBSTRING (SUBSTRING)
  (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SUBSTRING))
  (CL:LET* ((TESTSTRING (STRING-DOWNCASE SUBSTRING)) (TEST-VALUE NULL))
   (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING TESTSTRING))
   (CL:WHEN
    (CL:NOT (CL:EQ (CL:SETQ TEST-VALUE (MONTH (WRAP-STRING TESTSTRING))) NULL))
    (CL:RETURN-FROM MATCH-SUBSTRING
     (CONS-LIST SYM-DATE-TIME-PARSER-STELLA-MONTH TEST-VALUE)))
   (CL:WHEN
    (CL:NOT
     (CL:EQ (CL:SETQ TEST-VALUE (WEEKDAY (WRAP-STRING TESTSTRING))) NULL))
    (CL:RETURN-FROM MATCH-SUBSTRING
     (CONS-LIST SYM-DATE-TIME-PARSER-STELLA-WEEKDAY TEST-VALUE)))
   (CL:WHEN
    (CL:NOT (CL:EQ (CL:SETQ TEST-VALUE (AM-PM (WRAP-STRING TESTSTRING))) NULL))
    (CL:RETURN-FROM MATCH-SUBSTRING
     (CONS-LIST SYM-DATE-TIME-PARSER-STELLA-AM-PM TEST-VALUE)))
   (CL:WHEN
    (CL:NOT
     (CL:EQ (CL:SETQ TEST-VALUE (NOON-MIDN (WRAP-STRING TESTSTRING))) NULL))
    (CL:RETURN-FROM MATCH-SUBSTRING
     (CONS-LIST SYM-DATE-TIME-PARSER-STELLA-NOON-MIDN TEST-VALUE)))
   (CL:WHEN
    (CL:NOT (CL:EQ (CL:SETQ TEST-VALUE (ZONE (WRAP-STRING TESTSTRING))) NULL))
    (CL:RETURN-FROM MATCH-SUBSTRING
     (CONS-LIST SYM-DATE-TIME-PARSER-STELLA-ZONE TEST-VALUE)))
   (CL:WHEN
    (CL:NOT
     (CL:EQ (CL:SETQ TEST-VALUE (SPECIALP (WRAP-STRING TESTSTRING))) NULL))
    (CL:RETURN-FROM MATCH-SUBSTRING
     (CONS-LIST SYM-DATE-TIME-PARSER-STELLA-SPECIAL TEST-VALUE)))
   (CL:IF *ERROR-ON-MISMATCH*
    (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
     (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000)
      "\"~A\" is not a recognized word or abbreviation.`" SUBSTRING "'")
     (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))
    (CL:RETURN-FROM MATCH-SUBSTRING NIL))))

;;; (DEFUN (DIGIT-VALUE INTEGER) ...)

(CL:DEFUN DIGIT-VALUE (CHAR)
  (CL:RETURN-FROM DIGIT-VALUE
   (CL:- (CL:THE CL:FIXNUM (CL:CHAR-CODE CHAR))
    (CL:THE CL:FIXNUM (CL:CHAR-CODE #\0)))))
(CL:DECLAIM (CL:FTYPE (CL:FUNCTION (CL:T) CL:FIXNUM) DIGIT-VALUE))

;;; (DEFUN (DECOMPOSE-DATE-TIME-STRING CONS) ...)

(CL:DEFUN DECOMPOSE-DATE-TIME-STRING (STRING START END)
  (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING STRING) (CL:TYPE CL:FIXNUM START END))
  (CL:LET*
   ((STRING-INDEX START) (NEXT-NEGATIVE? FALSE) (PARTS-LIST NIL)
    (NEXT-CHAR NULL-CHARACTER) (PREV-CHAR NULL-CHARACTER))
   (CL:DECLARE (CL:TYPE CL:FIXNUM STRING-INDEX))
   (CL:WHEN (NULL? END) (CL:SETQ END (CL:THE CL:FIXNUM (CL:LENGTH STRING))))
   (CL:LOOP WHILE (CL:< STRING-INDEX END) DO
    (CL:SETQ NEXT-CHAR
     (CL:LET ((SELF STRING) (POSITION STRING-INDEX))
      (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF) (CL:TYPE CL:FIXNUM POSITION))
      (CL:AREF (CL:THE CL:SIMPLE-STRING SELF) (CL:THE CL:FIXNUM POSITION))))
    (CL:SETQ PREV-CHAR
     (CL:IF (CL:= STRING-INDEX START) NULL-CHARACTER
      (CL:LET ((SELF STRING) (POSITION (CL:1- STRING-INDEX)))
       (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF)
        (CL:TYPE CL:FIXNUM POSITION))
       (CL:AREF (CL:THE CL:SIMPLE-STRING SELF) (CL:THE CL:FIXNUM POSITION)))))
    (CL:COND
     ((CL:EQ
       (CL:AREF *CHARACTER-TYPE-TABLE*
        (CL:THE CL:FIXNUM (CL:CHAR-CODE NEXT-CHAR)))
       KWD-DATE-TIME-PARSER-LETTER)
      (CL:LET* ((SCAN-INDEX NULL-INTEGER) (ITER-000 (CL:1+ STRING-INDEX)))
       (CL:DECLARE (CL:TYPE CL:FIXNUM ITER-000 SCAN-INDEX))
       (CL:LOOP WHILE TRUE DO
        (CL:PROGN (CL:SETQ SCAN-INDEX ITER-000)
         (CL:SETQ ITER-000 (CL:1+ ITER-000)))
        (CL:WHEN
         (CL:OR (CL:= SCAN-INDEX END)
          (CL:NOT
           (CL:EQ
            (CL:AREF *CHARACTER-TYPE-TABLE*
             (CL:THE CL:FIXNUM
              (CL:CHAR-CODE
               (CL:LET ((SELF STRING) (POSITION SCAN-INDEX))
                (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF)
                 (CL:TYPE CL:FIXNUM POSITION))
                (CL:AREF (CL:THE CL:SIMPLE-STRING SELF)
                 (CL:THE CL:FIXNUM POSITION))))))
            KWD-DATE-TIME-PARSER-LETTER)))
         (CL:LET*
          ((MATCH-SYMBOL
            (MATCH-SUBSTRING (SUBSEQUENCE STRING STRING-INDEX SCAN-INDEX))))
          (CL:IF (CL:EQ MATCH-SYMBOL NIL)
           (CL:RETURN-FROM DECOMPOSE-DATE-TIME-STRING NIL)
           (CL:SETQ PARTS-LIST (CONS MATCH-SYMBOL PARTS-LIST))))
         (CL:SETQ STRING-INDEX SCAN-INDEX) (CL:RETURN)))))
     ((CL:EQ
       (CL:AREF *CHARACTER-TYPE-TABLE*
        (CL:THE CL:FIXNUM (CL:CHAR-CODE NEXT-CHAR)))
       KWD-DATE-TIME-PARSER-DIGIT)
      (CL:LET*
       ((NUMERIC-VALUE (DIGIT-VALUE NEXT-CHAR)) (FRACTIONAL-VALUE 0)
        (FRACTIONAL-DIVISOR 1.0d0) (IN-FRACTION? FALSE))
       (CL:DECLARE (CL:TYPE CL:FIXNUM NUMERIC-VALUE FRACTIONAL-VALUE)
        (CL:TYPE CL:DOUBLE-FLOAT FRACTIONAL-DIVISOR))
       (CL:LET* ((SCAN-INDEX NULL-INTEGER) (ITER-001 (CL:1+ STRING-INDEX)))
        (CL:DECLARE (CL:TYPE CL:FIXNUM ITER-001 SCAN-INDEX))
        (CL:LOOP WHILE TRUE DO
         (CL:PROGN (CL:SETQ SCAN-INDEX ITER-001)
          (CL:SETQ ITER-001 (CL:1+ ITER-001)))
         (CL:WHEN
          (CL:OR (CL:= SCAN-INDEX END)
           (CL:NOT
            (CL:OR
             (CL:EQ
              (CL:AREF *CHARACTER-TYPE-TABLE*
               (CL:THE CL:FIXNUM
                (CL:CHAR-CODE
                 (CL:LET ((SELF STRING) (POSITION SCAN-INDEX))
                  (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF)
                   (CL:TYPE CL:FIXNUM POSITION))
                  (CL:AREF (CL:THE CL:SIMPLE-STRING SELF)
                   (CL:THE CL:FIXNUM POSITION))))))
              KWD-DATE-TIME-PARSER-DIGIT)
             (CL:AND (CL:NOT IN-FRACTION?)
              (CL:EQL
               (CL:LET ((SELF STRING) (POSITION SCAN-INDEX))
                (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF)
                 (CL:TYPE CL:FIXNUM POSITION))
                (CL:AREF (CL:THE CL:SIMPLE-STRING SELF)
                 (CL:THE CL:FIXNUM POSITION)))
               #\.)))))
          (CL:WHEN NEXT-NEGATIVE? (CL:SETQ NEXT-NEGATIVE? FALSE)
           (CL:SETQ NUMERIC-VALUE (CL:- 0 NUMERIC-VALUE))
           (CL:SETQ FRACTIONAL-VALUE (CL:- 0 FRACTIONAL-VALUE)))
          (CL:IF IN-FRACTION?
           (CL:SETQ PARTS-LIST
            (CONS
             (WRAP-FLOAT
              (CL:+ NUMERIC-VALUE (CL:/ FRACTIONAL-VALUE FRACTIONAL-DIVISOR)))
             PARTS-LIST))
           (CL:SETQ PARTS-LIST (CONS (WRAP-INTEGER NUMERIC-VALUE) PARTS-LIST)))
          (CL:SETQ STRING-INDEX SCAN-INDEX) (CL:RETURN))
         (CL:COND
          (IN-FRACTION?
           (CL:SETQ FRACTIONAL-VALUE
            (CL:+ (CL:* FRACTIONAL-VALUE 10)
             (DIGIT-VALUE
              (CL:LET ((SELF STRING) (POSITION SCAN-INDEX))
               (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF)
                (CL:TYPE CL:FIXNUM POSITION))
               (CL:AREF (CL:THE CL:SIMPLE-STRING SELF)
                (CL:THE CL:FIXNUM POSITION))))))
           (CL:SETQ FRACTIONAL-DIVISOR (CL:* FRACTIONAL-DIVISOR 10.0d0)))
          ((CL:EQL
            (CL:LET ((SELF STRING) (POSITION SCAN-INDEX))
             (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF)
              (CL:TYPE CL:FIXNUM POSITION))
             (CL:AREF (CL:THE CL:SIMPLE-STRING SELF)
              (CL:THE CL:FIXNUM POSITION)))
            #\.)
           (CL:SETQ IN-FRACTION? TRUE))
          (CL:T
           (CL:SETQ NUMERIC-VALUE
            (CL:+ (CL:* NUMERIC-VALUE 10)
             (DIGIT-VALUE
              (CL:LET ((SELF STRING) (POSITION SCAN-INDEX))
               (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF)
                (CL:TYPE CL:FIXNUM POSITION))
               (CL:AREF (CL:THE CL:SIMPLE-STRING SELF)
                (CL:THE CL:FIXNUM POSITION))))))))))))
     ((CL:AND (CL:EQL NEXT-CHAR #\-)
       (CL:OR (NULL? PREV-CHAR)
        (MEMBER? WHITESPACE-CHARS (WRAP-CHARACTER PREV-CHAR))
        (MEMBER? DATE-DIVIDERS (WRAP-CHARACTER PREV-CHAR))))
      (CL:SETQ NEXT-NEGATIVE? TRUE)
      (CL:SETQ STRING-INDEX (CL:1+ STRING-INDEX)))
     ((MEMBER? TIME-DIVIDERS (WRAP-CHARACTER NEXT-CHAR))
      (CL:SETQ PARTS-LIST
       (CONS
        (CONS-LIST SYM-DATE-TIME-PARSER-STELLA-TIME-DIVIDER
         (WRAP-CHARACTER NEXT-CHAR))
        PARTS-LIST))
      (CL:SETQ STRING-INDEX (CL:1+ STRING-INDEX)))
     ((MEMBER? DATE-DIVIDERS (WRAP-CHARACTER NEXT-CHAR))
      (CL:SETQ PARTS-LIST
       (CONS
        (CONS-LIST SYM-DATE-TIME-PARSER-STELLA-DATE-DIVIDER
         (WRAP-CHARACTER NEXT-CHAR))
        PARTS-LIST))
      (CL:SETQ STRING-INDEX (CL:1+ STRING-INDEX)))
     ((MEMBER? WHITESPACE-CHARS (WRAP-CHARACTER NEXT-CHAR))
      (CL:SETQ STRING-INDEX (CL:1+ STRING-INDEX)))
     ((CL:EQL NEXT-CHAR #\+)
      (CL:SETQ PARTS-LIST
       (CONS
        (CONS-LIST SYM-DATE-TIME-PARSER-STELLA-DATE-DIVIDER
         (WRAP-CHARACTER NEXT-CHAR))
        PARTS-LIST))
      (CL:SETQ STRING-INDEX (CL:1+ STRING-INDEX)))
     ((CL:EQL NEXT-CHAR #\()
      (CL:LOOP WHILE
       (CL:AND (CL:NOT (CL:= STRING-INDEX END))
        (CL:NOT
         (CL:EQL
          (CL:LET ((SELF STRING) (POSITION STRING-INDEX))
           (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING SELF)
            (CL:TYPE CL:FIXNUM POSITION))
           (CL:AREF (CL:THE CL:SIMPLE-STRING SELF)
            (CL:THE CL:FIXNUM POSITION)))
          #\))))
       DO (CL:SETQ STRING-INDEX (CL:1+ STRING-INDEX))))
     (CL:T
      (CL:IF *ERROR-ON-MISMATCH*
       (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
        (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000)
         ">>> Bogus character at position `" STRING-INDEX "' in \"`" STRING
         "'\"")
        (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))
       (CL:RETURN-FROM DECOMPOSE-DATE-TIME-STRING NIL)))))
   (CL:RETURN-FROM DECOMPOSE-DATE-TIME-STRING (REVERSE PARTS-LIST))))

;;; (DEFUN (MATCH-PATTERN-ELEMENT CONS) ...)

(CL:DEFUN MATCH-PATTERN-ELEMENT (PATTERN-ELEMENT DATUM-ELEMENT)
  (CL:COND
   ((ISA? DATUM-ELEMENT SGT-DATE-TIME-PARSER-STELLA-CONS)
    (CL:LET*
     ((DATUM-TYPE
       (CL:IF
        (CL:EQ (%%VALUE DATUM-ELEMENT) SYM-DATE-TIME-PARSER-STELLA-SPECIAL)
        (%%VALUE (%%REST DATUM-ELEMENT)) (%%VALUE DATUM-ELEMENT))))
     (CL:IF (CL:EQ DATUM-TYPE PATTERN-ELEMENT)
      (CL:RETURN-FROM MATCH-PATTERN-ELEMENT DATUM-ELEMENT)
      (CL:RETURN-FROM MATCH-PATTERN-ELEMENT NIL))))
   ((MEMBER? *SPECIAL-SYMBOLS* PATTERN-ELEMENT)
    (CL:RETURN-FROM MATCH-PATTERN-ELEMENT NIL))
   (CL:T
    (CL:LET*
     ((FUNCTION (%FUNCTION-CODE (LOOKUP-FUNCTION PATTERN-ELEMENT)))
      (MATCH (CL:FUNCALL FUNCTION DATUM-ELEMENT)))
     (CL:COND
      ((SUBTYPE-OF-BOOLEAN? (SAFE-PRIMARY-TYPE MATCH))
       (CL:PROGN
        (CL:IF (COERCE-WRAPPED-BOOLEAN-TO-BOOLEAN MATCH)
         (CL:RETURN-FROM MATCH-PATTERN-ELEMENT
          (CONS-LIST PATTERN-ELEMENT DATUM-ELEMENT))
         (CL:RETURN-FROM MATCH-PATTERN-ELEMENT NIL))))
      (CL:T
       (CL:IF (CL:NOT (CL:EQ MATCH NULL))
        (CL:RETURN-FROM MATCH-PATTERN-ELEMENT
         (CONS-LIST PATTERN-ELEMENT MATCH))
        (CL:RETURN-FROM MATCH-PATTERN-ELEMENT NIL))))))))

;;; (DEFUN (MATCH-PATTERN CONS) ...)

(CL:DEFUN MATCH-PATTERN (PATTERN DATUM DATUM-LENGTH)
  (CL:DECLARE (CL:TYPE CL:FIXNUM DATUM-LENGTH))
  (CL:IF (CL:< (LENGTH PATTERN) DATUM-LENGTH)
   (CL:RETURN-FROM MATCH-PATTERN NIL)
   (CL:LET*
    ((FORM-LIST NIL) (PATTERN-CURSOR PATTERN) (DATUM-CURSOR DATUM)
     (PATTERN-ELEMENT NULL) (DATUM-ELEMENT NULL) (OPTIONAL? FALSE)
     (MATCHING NIL))
    (CL:LOOP WHILE
     (CL:NOT (CL:OR (CL:EQ PATTERN-CURSOR NIL) (CL:EQ DATUM-CURSOR NIL))) DO
     (CL:SETQ PATTERN-ELEMENT (%%VALUE PATTERN-CURSOR))
     (CL:SETQ DATUM-ELEMENT (%%VALUE DATUM-CURSOR))
     (CL:SETQ OPTIONAL?
      (ISA? PATTERN-ELEMENT SGT-DATE-TIME-PARSER-STELLA-CONS))
     (CL:SETQ MATCHING
      (MATCH-PATTERN-ELEMENT
       (CL:IF OPTIONAL? (%%VALUE PATTERN-ELEMENT) PATTERN-ELEMENT)
       DATUM-ELEMENT))
     (CL:COND
      ((CL:NOT (CL:EQ MATCHING NIL))
       (CL:LET* ((FORM-TYPE (%%VALUE MATCHING)))
        (CL:WHEN
         (CL:NOT
          (CL:OR (CL:EQ FORM-TYPE SYM-DATE-TIME-PARSER-STELLA-TIME-DIVIDER)
           (CL:EQ FORM-TYPE SYM-DATE-TIME-PARSER-STELLA-DATE-DIVIDER)))
         (CL:SETQ FORM-LIST (CONS MATCHING FORM-LIST)))))
      (OPTIONAL? (CL:SETQ DATUM-CURSOR (CONS DATUM-ELEMENT DATUM-CURSOR)))
      (CL:T (CL:RETURN-FROM MATCH-PATTERN NIL)))
     (CL:SETQ PATTERN-CURSOR (%%REST PATTERN-CURSOR))
     (CL:SETQ DATUM-CURSOR (%%REST DATUM-CURSOR)))
    (CL:COND
     ((CL:AND (CL:EQ PATTERN-CURSOR NIL) (CL:EQ DATUM-CURSOR NIL))
      (CL:RETURN-FROM MATCH-PATTERN (REVERSE FORM-LIST)))
     ((CL:EQ PATTERN-CURSOR NIL) (CL:RETURN-FROM MATCH-PATTERN NIL))
     ((CL:EQ DATUM-CURSOR NIL)
      (CL:LET* ((ELEMENT NULL) (ITER-000 PATTERN-CURSOR))
       (CL:LOOP WHILE (CL:NOT (CL:EQ ITER-000 NIL)) DO
        (CL:PROGN (CL:SETQ ELEMENT (%%VALUE ITER-000))
         (CL:SETQ ITER-000 (%%REST ITER-000)))
        (CL:WHEN (CL:NOT (ISA? ELEMENT SGT-DATE-TIME-PARSER-STELLA-CONS))
         (CL:RETURN-FROM MATCH-PATTERN NIL))))
      (CL:RETURN-FROM MATCH-PATTERN (REVERSE FORM-LIST)))
     (CL:T (CL:ERROR (NEW-STELLA-EXCEPTION "Shouldn't get here!")))))))

;;; (DEFUN DEAL-WITH-NOON-MIDN ...)

(CL:DEFUN DEAL-WITH-NOON-MIDN (FORM-VALUE PARSED-VALUES)
  (CL:COND
   ((CL:EQ FORM-VALUE SYM-DATE-TIME-PARSER-STELLA-NOON)
    (CL:SETF (%DATE-TIME-HOUR PARSED-VALUES) 12))
   ((CL:EQ FORM-VALUE SYM-DATE-TIME-PARSER-STELLA-MIDN)
    (CL:SETF (%DATE-TIME-HOUR PARSED-VALUES) 0))
   (CL:T
    (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
     (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "Unrecognized symbol: ~A`"
      FORM-VALUE "'")
     (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))))
  (CL:SETF (%DATE-TIME-MINUTE PARSED-VALUES) 0)
  (CL:SETF (%DATE-TIME-SECOND PARSED-VALUES) 0)
  :VOID)

;;; (DEFUN DEAL-WITH-AM-PM ...)

(CL:DEFUN DEAL-WITH-AM-PM (FORM-VALUE PARSED-VALUES)
  (CL:LET* ((HOUR (%DATE-TIME-HOUR PARSED-VALUES)))
   (CL:DECLARE (CL:TYPE CL:FIXNUM HOUR))
   (CL:COND
    ((CL:EQ FORM-VALUE SYM-DATE-TIME-PARSER-STELLA-AM)
     (CL:COND ((CL:= HOUR 12) (CL:SETF (%DATE-TIME-HOUR PARSED-VALUES) 0))
      ((CL:NOT (CL:AND (CL:<= 0 HOUR) (CL:<= HOUR 12)))
       (CL:WHEN *ERROR-ON-MISMATCH*
        (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
         (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" HOUR
          "' is not an AM hour.")
         (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))))))
    ((CL:EQ FORM-VALUE SYM-DATE-TIME-PARSER-STELLA-PM)
     (CL:WHEN (CL:AND (CL:<= 0 HOUR) (CL:<= HOUR 11))
      (CL:SETF (%DATE-TIME-HOUR PARSED-VALUES) (CL:+ HOUR 12))))
    (CL:T
     (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
      (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001) "`" FORM-VALUE
       "'isn't AM/PM - this shouldn't happen.")
      (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001)))))))
  :VOID)

;;; (DEFUN SET-TIME-VALUES ...)

(CL:DEFUN SET-TIME-VALUES (STRING-FORM PARSED-VALUES)
  (CL:LET* ((FORM-TYPE NULL) (FORM-VALUE NULL))
   (CL:LET* ((FORM-PART NULL) (ITER-000 STRING-FORM))
    (CL:LOOP WHILE (CL:NOT (CL:EQ ITER-000 NIL)) DO
     (CL:PROGN (CL:SETQ FORM-PART (%%VALUE ITER-000))
      (CL:SETQ ITER-000 (%%REST ITER-000)))
     (CL:SETQ FORM-TYPE (%%VALUE FORM-PART))
     (CL:SETQ FORM-VALUE (%%VALUE (%%REST FORM-PART)))
     (CL:LET* ((TEST-VALUE-000 FORM-TYPE))
      (CL:COND
       ((CL:EQ TEST-VALUE-000 SYM-DATE-TIME-PARSER-STELLA-SECONDP)
        (CL:LET* ((TEST-VALUE-001 (SAFE-PRIMARY-TYPE FORM-VALUE)))
         (CL:COND
          ((SUBTYPE-OF-INTEGER? TEST-VALUE-001)
           (CL:PROGN
            (CL:SETF (%DATE-TIME-SECOND PARSED-VALUES)
             (%WRAPPER-VALUE FORM-VALUE))))
          ((SUBTYPE-OF-FLOAT? TEST-VALUE-001)
           (CL:PROGN
            (CL:SETF (%DATE-TIME-SECOND PARSED-VALUES)
             (FLOOR (%WRAPPER-VALUE FORM-VALUE)))
            (CL:SETF (%DATE-TIME-MILLIS PARSED-VALUES)
             (ROUND
              (CL:* 1000.0d0
               (CL:- (%WRAPPER-VALUE FORM-VALUE)
                (FLOOR (%WRAPPER-VALUE FORM-VALUE))))))))
          (CL:T
           (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
            (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-001
             "' is not a valid case option")
            (CL:ERROR
             (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))))))
       ((CL:EQ TEST-VALUE-000 SYM-DATE-TIME-PARSER-STELLA-MINUTE)
        (CL:SETF (%DATE-TIME-MINUTE PARSED-VALUES)
         (%WRAPPER-VALUE FORM-VALUE)))
       ((CL:EQ TEST-VALUE-000 SYM-DATE-TIME-PARSER-STELLA-HOUR)
        (CL:SETF (%DATE-TIME-HOUR PARSED-VALUES) (%WRAPPER-VALUE FORM-VALUE)))
       ((CL:EQ TEST-VALUE-000 SYM-DATE-TIME-PARSER-STELLA-DAY)
        (CL:SETF (%DATE-TIME-DAY PARSED-VALUES) (%WRAPPER-VALUE FORM-VALUE)))
       ((CL:EQ TEST-VALUE-000 SYM-DATE-TIME-PARSER-STELLA-MONTH)
        (CL:SETF (%DATE-TIME-MONTH PARSED-VALUES) (%WRAPPER-VALUE FORM-VALUE)))
       ((CL:EQ TEST-VALUE-000 SYM-DATE-TIME-PARSER-STELLA-YEAR)
        (CL:SETF (%DATE-TIME-YEAR PARSED-VALUES) (%WRAPPER-VALUE FORM-VALUE)))
       ((CL:EQ TEST-VALUE-000 SYM-DATE-TIME-PARSER-STELLA-ZONE)
        (CL:SETF (%DATE-TIME-ZONE PARSED-VALUES) (%WRAPPER-VALUE FORM-VALUE)))
       ((CL:EQ TEST-VALUE-000 SYM-DATE-TIME-PARSER-STELLA-WEEKDAY)
        (CL:SETF (%DATE-TIME-DOW PARSED-VALUES) FORM-VALUE))
       ((CL:EQ TEST-VALUE-000 SYM-DATE-TIME-PARSER-STELLA-AM-PM)
        (DEAL-WITH-AM-PM FORM-VALUE PARSED-VALUES))
       ((CL:EQ TEST-VALUE-000 SYM-DATE-TIME-PARSER-STELLA-NOON-MIDN)
        (DEAL-WITH-NOON-MIDN FORM-VALUE PARSED-VALUES))
       ((CL:EQ TEST-VALUE-000 SYM-DATE-TIME-PARSER-STELLA-SPECIAL)
        (CL:FUNCALL (%FUNCTION-CODE (LOOKUP-FUNCTION FORM-VALUE))
         PARSED-VALUES))
       (CL:T
        (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
         (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001)
          "Unrecognized symbol in form list: ~A.`" FORM-TYPE "'")
         (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001))))))))))
  :VOID)

;;; (DEFUN (PARSE-DATE-TIME DECODED-DATE-TIME) ...)

(CL:DEFUN PARSE-DATE-TIME (DATE-TIME-STRING START END ERROR-ON-MISMATCH?)
  "Tries very hard to make sense out of the argument `date-time-string' and
returns a time structure if successful.  If not, it returns `null'.
If `error-on-mismatch?' is true, parse-date-time will signal an error instead of
returning `null'.  
Default values are 00:00:00 UTC on the current date"
  (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING DATE-TIME-STRING)
   (CL:TYPE CL:FIXNUM START END))
  (CL:LET* ((*ERROR-ON-MISMATCH* ERROR-ON-MISMATCH?))
   (CL:DECLARE (CL:SPECIAL *ERROR-ON-MISMATCH*))
   (CL:LET*
    ((STRING-PARTS (DECOMPOSE-DATE-TIME-STRING DATE-TIME-STRING START END))
     (PARTS-LENGTH (LENGTH STRING-PARTS)) (STRING-FORM NIL))
    (CL:DECLARE (CL:TYPE CL:FIXNUM PARTS-LENGTH))
    (CL:LET* ((PATTERN NULL) (ITER-000 *DATE-TIME-PATTERNS*))
     (CL:LOOP WHILE (CL:NOT (CL:EQ ITER-000 NIL)) DO
      (CL:PROGN (CL:SETQ PATTERN (%%VALUE ITER-000))
       (CL:SETQ ITER-000 (%%REST ITER-000)))
      (CL:SETQ STRING-FORM (MATCH-PATTERN PATTERN STRING-PARTS PARTS-LENGTH))
      (CL:WHEN (CL:NOT (CL:EQ STRING-FORM NIL)) (CL:RETURN))))
    (CL:IF (CL:EQ STRING-FORM NIL)
     (CL:IF *ERROR-ON-MISMATCH*
      (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
       (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "\"`" DATE-TIME-STRING
        "'\" is not a recognized time/date format.")
       (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))
      (CL:RETURN-FROM PARSE-DATE-TIME NULL))
     (CL:LET*
      ((PARSED-VALUES
        (DECODE-CALENDAR-DATE (MAKE-CURRENT-DATE-TIME) (GET-LOCAL-TIME-ZONE))))
      (CL:SETF (%DATE-TIME-MILLIS PARSED-VALUES) 0)
      (CL:SETF (%DATE-TIME-SECOND PARSED-VALUES) 0)
      (CL:SETF (%DATE-TIME-MINUTE PARSED-VALUES) 0)
      (CL:SETF (%DATE-TIME-HOUR PARSED-VALUES) 0)
      (SET-TIME-VALUES STRING-FORM PARSED-VALUES)
      (CL:RETURN-FROM PARSE-DATE-TIME PARSED-VALUES))))))

;;; (DEFUN (STRING-TO-CALENDAR-DATE CALENDAR-DATE) ...)

(CL:DEFUN STRING-TO-CALENDAR-DATE (INPUT)
  "Returns a calendar date object representing the date and time
parsed from the `input' string.  If no valid parse is found,
`null' is returned."
  (CL:DECLARE (CL:TYPE CL:SIMPLE-STRING INPUT))
  (CL:LET* ((DO (PARSE-DATE-TIME INPUT 0 NULL-INTEGER FALSE)))
   (CL:IF (CL:EQ DO NULL) (CL:RETURN-FROM STRING-TO-CALENDAR-DATE NULL)
    (CL:RETURN-FROM STRING-TO-CALENDAR-DATE (ENCODE-CALENDAR-DATE DO)))))

(CL:DEFUN HELP-STARTUP-DATE-TIME-PARSER1 ()
  (CL:PROGN
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-FOREACH
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FOREACH" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-ITEM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ITEM" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-IN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "IN" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-CAST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CAST" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-CONS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CONS" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "OF" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-DO
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DO" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-INSERT-AT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INSERT-AT" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-FIRST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FIRST" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-SECOND
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SECOND" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-AM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "AM" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-PM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PM" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-NOON
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NOON" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-MIDN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MIDN" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-MONTH
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MONTH" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-WEEKDAY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "WEEKDAY" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-AM-PM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "AM-PM" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-NOON-MIDN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NOON-MIDN" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-ZONE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ZONE" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-SPECIAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SPECIAL" NULL 0))
   (CL:SETQ KWD-DATE-TIME-PARSER-LETTER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LETTER" NULL 2))
   (CL:SETQ KWD-DATE-TIME-PARSER-DIGIT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DIGIT" NULL 2))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-TIME-DIVIDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "TIME-DIVIDER" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-DATE-DIVIDER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DATE-DIVIDER" NULL 0))
   (CL:SETQ SGT-DATE-TIME-PARSER-STELLA-CONS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CONS" NULL 1))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-SECONDP
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SECONDP" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-MINUTE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MINUTE" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-HOUR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "HOUR" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-DAY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DAY" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-YEAR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "YEAR" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-STARTUP-DATE-TIME-PARSER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STARTUP-DATE-TIME-PARSER" NULL 0))
   (CL:SETQ SYM-DATE-TIME-PARSER-STELLA-METHOD-STARTUP-CLASSNAME
    (INTERN-RIGID-SYMBOL-WRT-MODULE "METHOD-STARTUP-CLASSNAME" NULL 0)))
  :VOID)

(CL:DEFUN STARTUP-DATE-TIME-PARSER ()
  (CL:LET* ((*MODULE* *STELLA-MODULE*) (*CONTEXT* *MODULE*))
   (CL:DECLARE (CL:SPECIAL *MODULE* *CONTEXT*))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 2) (HELP-STARTUP-DATE-TIME-PARSER1))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 4)
    (CL:SETQ WHITESPACE-CHARS
     (GET-QUOTED-TREE "((#\\  #\\Tab #\\Linefeed #\\, #\\' #\\`) \"/STELLA\")"
      "/STELLA"))
    (CL:SETQ TIME-DIVIDERS
     (GET-QUOTED-TREE "((#\\: #\\.) \"/STELLA\")" "/STELLA"))
    (CL:SETQ DATE-DIVIDERS
     (GET-QUOTED-TREE "((#\\\\ #\\/ #\\-) \"/STELLA\")" "/STELLA"))
    (CL:SETQ *WEEKDAY-STRINGS* (NEW-STRING-HASH-TABLE))
    (CL:SETQ *MONTH-STRINGS* (NEW-STRING-TO-INTEGER-HASH-TABLE))
    (CL:SETQ *ZONE-STRINGS* (NEW-STRING-HASH-TABLE))
    (CL:SETQ *SPECIAL-STRINGS* (NEW-STRING-HASH-TABLE))
    (CL:SETQ *SPECIAL-SYMBOLS*
     (GET-QUOTED-TREE "((YESTERDAY TODAY TOMORROW NOW) \"/STELLA\")"
      "/STELLA"))
    (CL:LET*
     ((ITEM NULL)
      (ITER-039
       (GET-QUOTED-TREE
        "(((\"monday\" :MONDAY) (\"mon\" :MONDAY) (\"tuesday\" :TUESDAY) (\"tues\" :TUESDAY) (\"tue\" :TUESDAY) (\"wednesday\" :WEDNESDAY) (\"wednes\" :WEDNESDAY) (\"wed\" :WEDNESDAY) (\"thursday\" :THURSDAY) (\"thurs\" :THURSDAY) (\"thu\" :THURSDAY) (\"friday\" :FRIDAY) (\"fri\" :FRIDAY) (\"saturday\" :SATURDAY) (\"sat\" :SATURDAY) (\"sunday\" :SUNDAY) (\"sun\" :SUNDAY)) \"/STELLA\")"
        "/STELLA")))
     (CL:LOOP WHILE (CL:NOT (CL:EQ ITER-039 NIL)) DO
      (CL:PROGN (CL:SETQ ITEM (%%VALUE ITER-039))
       (CL:SETQ ITER-039 (%%REST ITER-039)))
      (INSERT-AT *WEEKDAY-STRINGS* (%WRAPPER-VALUE (%%VALUE ITEM))
       (%%VALUE (%%REST ITEM)))))
    (CL:LET*
     ((ITEM NULL)
      (ITER-040
       (GET-QUOTED-TREE
        "(((\"january\" 1) (\"jan\" 1) (\"february\" 2) (\"feb\" 2) (\"march\" 3) (\"mar\" 3) (\"april\" 4) (\"apr\" 4) (\"may\" 5) (\"june\" 6) (\"jun\" 6) (\"july\" 7) (\"jul\" 7) (\"august\" 8) (\"aug\" 8) (\"september\" 9) (\"sept\" 9) (\"sep\" 9) (\"october\" 10) (\"oct\" 10) (\"november\" 11) (\"nov\" 11) (\"december\" 12) (\"dec\" 12)) \"/STELLA\")"
        "/STELLA")))
     (CL:LOOP WHILE (CL:NOT (CL:EQ ITER-040 NIL)) DO
      (CL:PROGN (CL:SETQ ITEM (%%VALUE ITER-040))
       (CL:SETQ ITER-040 (%%REST ITER-040)))
      (INSERT-AT *MONTH-STRINGS* (%WRAPPER-VALUE (%%VALUE ITEM))
       (%WRAPPER-VALUE (%%VALUE (%%REST ITEM))))))
    (CL:LET*
     ((ITEM NULL)
      (ITER-041
       (GET-QUOTED-TREE
        "(((\"gmt\" 0.0) (\"utc\" 0.0) (\"est\" -5.0) (\"edt\" -4.0) (\"cst\" -6.0) (\"cdt\" -5.0) (\"mst\" -7.0) (\"mdt\" -6.0) (\"pst\" -8.0) (\"pdt\" -7.0) (\"A\" 1.0) (\"B\" 2.0) (\"C\" 3.0) (\"C*\" 3.5) (\"D\" 4.0) (\"D*\" 4.5) (\"E\" 5.0) (\"E*\" 4.5) (\"F\" 6.0) (\"F*\" 6.5) (\"G\" 7.0) (\"H\" 7.0) (\"I\" 9.0) (\"I*\" 9.5) (\"K\" 10.0) (\"K*\" 10.5) (\"L\" 11.0) (\"L*\" 11.5) (\"M\" 12.0) (\"N\" -1.0) (\"O\" -2.0) (\"P\" -3.0) (\"P*\" -3.5) (\"Q\" -4.0) (\"R\" -5.0) (\"S\" -6.0) (\"T\" -7.0) (\"U\" -8.0) (\"U*\" -8.5) (\"V\" -9.0) (\"V*\" -9.5) (\"W\" -10.0) (\"X\" -11.0) (\"Y\" -12.0) (\"Z\" 0.0)) \"/STELLA\")"
        "/STELLA")))
     (CL:LOOP WHILE (CL:NOT (CL:EQ ITER-041 NIL)) DO
      (CL:PROGN (CL:SETQ ITEM (%%VALUE ITER-041))
       (CL:SETQ ITER-041 (%%REST ITER-041)))
      (INSERT-AT *ZONE-STRINGS* (%WRAPPER-VALUE (%%VALUE ITEM))
       (%%VALUE (%%REST ITEM)))))
    (CL:LET* ((SYMBOL NULL) (ITER-042 *SPECIAL-SYMBOLS*))
     (CL:LOOP WHILE (CL:NOT (CL:EQ ITER-042 NIL)) DO
      (CL:PROGN (CL:SETQ SYMBOL (%%VALUE ITER-042))
       (CL:SETQ ITER-042 (%%REST ITER-042)))
      (INSERT-AT *SPECIAL-STRINGS* (STRING-DOWNCASE (%SYMBOL-NAME SYMBOL))
       SYMBOL)))
    (CL:SETQ *DATE-TIME-PATTERNS*
     (GET-QUOTED-TREE
      "(((YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY (NOON-MIDN)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (NOON-MIDN) (DATE-DIVIDER) (ZONE)) (MONTH (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((NOON-MIDN) (WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR) ((NOON-MIDN) (WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR) ((NOON-MIDN) (WEEKDAY) MONTH (DATE-DIVIDER) DAY) ((NOON-MIDN) YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY) ((NOON-MIDN) MONTH (DATE-DIVIDER) YEAR) ((NOON-MIDN) YEAR (DATE-DIVIDER) MONTH) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (NOON-MIDN (DATE-DIVIDER) (ZONE)) (HOUR (NOON-MIDN)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY NOON-MIDN (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY NOW) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) MONTH (DATE-DIVIDER) DAY) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) MONTH (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) YEAR (DATE-DIVIDER) MONTH) (WEEKDAY MONTH DAY HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) SECONDP (AM-PM) (ZONE) YEAR) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) (MONTH)) (MONTH (DATE-DIVIDER) (YEAR)) ((WEEKDAY) MONTH DAY HOUR TIME-DIVIDER MINUTE (TIME-DIVIDER) (SECONDP) YEAR) (NOW (YESTERDAY)) ((YESTERDAY) NOW) (NOW (TODAY)) ((TODAY) NOW) (NOW (TOMORROW)) ((TOMORROW) NOW) (YESTERDAY (NOON-MIDN)) ((NOON-MIDN) YESTERDAY) (TODAY (NOON-MIDN)) ((NOON-MIDN) TODAY) (TOMORROW (NOON-MIDN)) ((NOON-MIDN) TOMORROW) (YESTERDAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (TOMORROW HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (TODAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE))) \"/STELLA\")"
      "/STELLA")))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 6) (FINALIZE-CLASSES))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 7)
    (DEFINE-FUNCTION-OBJECT "HASHLIST"
     "(DEFUN HASHLIST ((LIST OBJECT) (TABLE OBJECT)) :TYPE OBJECT :MACRO? TRUE)"
     (CL:FUNCTION HASHLIST) NULL)
    (DEFINE-FUNCTION-OBJECT "YESTERDAY"
     "(DEFUN YESTERDAY ((PARSED-VALUES DECODED-DATE-TIME)))"
     (CL:FUNCTION YESTERDAY) NULL)
    (DEFINE-FUNCTION-OBJECT "TODAY"
     "(DEFUN TODAY ((PARSED-VALUES DECODED-DATE-TIME)))" (CL:FUNCTION TODAY)
     NULL)
    (DEFINE-FUNCTION-OBJECT "TOMORROW"
     "(DEFUN TOMORROW ((PARSED-VALUES DECODED-DATE-TIME)))"
     (CL:FUNCTION TOMORROW) NULL)
    (DEFINE-FUNCTION-OBJECT "NOW"
     "(DEFUN NOW ((PARSED-VALUES DECODED-DATE-TIME)))" (CL:FUNCTION NOW) NULL)
    (DEFINE-FUNCTION-OBJECT "AM-PM" "(DEFUN (AM-PM SYMBOL) ((STRING OBJECT)))"
     (CL:FUNCTION AM-PM) NULL)
    (DEFINE-FUNCTION-OBJECT "NOON-MIDN"
     "(DEFUN (NOON-MIDN SYMBOL) ((STRING OBJECT)))" (CL:FUNCTION NOON-MIDN)
     NULL)
    (DEFINE-FUNCTION-OBJECT "WEEKDAY"
     "(DEFUN (WEEKDAY KEYWORD) ((THING OBJECT)))" (CL:FUNCTION WEEKDAY) NULL)
    (DEFINE-FUNCTION-OBJECT "MONTH"
     "(DEFUN (MONTH INTEGER-WRAPPER) ((THING OBJECT)))" (CL:FUNCTION MONTH)
     NULL)
    (DEFINE-FUNCTION-OBJECT "ZONE"
     "(DEFUN (ZONE FLOAT-WRAPPER) ((THING OBJECT)))" (CL:FUNCTION ZONE) NULL)
    (DEFINE-FUNCTION-OBJECT "SPECIALP"
     "(DEFUN (SPECIALP SYMBOL) ((STRING OBJECT)))" (CL:FUNCTION SPECIALP) NULL)
    (DEFINE-FUNCTION-OBJECT "SECONDP"
     "(DEFUN (SECONDP BOOLEAN-WRAPPER) ((NUMBER OBJECT)))"
     (CL:FUNCTION SECONDP) NULL)
    (DEFINE-FUNCTION-OBJECT "MINUTE"
     "(DEFUN (MINUTE BOOLEAN-WRAPPER) ((NUMBER OBJECT)))" (CL:FUNCTION MINUTE)
     NULL)
    (DEFINE-FUNCTION-OBJECT "HOUR"
     "(DEFUN (HOUR BOOLEAN-WRAPPER) ((NUMBER OBJECT)))" (CL:FUNCTION HOUR)
     NULL)
    (DEFINE-FUNCTION-OBJECT "DAY"
     "(DEFUN (DAY BOOLEAN-WRAPPER) ((NUMBER OBJECT)))" (CL:FUNCTION DAY) NULL)
    (DEFINE-FUNCTION-OBJECT "YEAR"
     "(DEFUN (YEAR BOOLEAN-WRAPPER) ((NUMBER OBJECT)))" (CL:FUNCTION YEAR)
     NULL)
    (DEFINE-FUNCTION-OBJECT "TIME-DIVIDER"
     "(DEFUN (TIME-DIVIDER BOOLEAN-WRAPPER) ((THECHARACTER OBJECT)))"
     (CL:FUNCTION TIME-DIVIDER) NULL)
    (DEFINE-FUNCTION-OBJECT "DATE-DIVIDER"
     "(DEFUN (DATE-DIVIDER BOOLEAN-WRAPPER) ((THECHARACTER OBJECT)))"
     (CL:FUNCTION DATE-DIVIDER) NULL)
    (DEFINE-FUNCTION-OBJECT "MATCH-SUBSTRING"
     "(DEFUN (MATCH-SUBSTRING CONS) ((SUBSTRING STRING)))"
     (CL:FUNCTION MATCH-SUBSTRING) NULL)
    (DEFINE-FUNCTION-OBJECT "DIGIT-VALUE"
     "(DEFUN (DIGIT-VALUE INTEGER) ((CHAR CHARACTER)))"
     (CL:FUNCTION DIGIT-VALUE) NULL)
    (DEFINE-FUNCTION-OBJECT "DECOMPOSE-DATE-TIME-STRING"
     "(DEFUN (DECOMPOSE-DATE-TIME-STRING CONS) ((STRING STRING) (START INTEGER) (END INTEGER)))"
     (CL:FUNCTION DECOMPOSE-DATE-TIME-STRING) NULL)
    (DEFINE-FUNCTION-OBJECT "MATCH-PATTERN-ELEMENT"
     "(DEFUN (MATCH-PATTERN-ELEMENT CONS) ((PATTERN-ELEMENT SYMBOL) (DATUM-ELEMENT OBJECT)))"
     (CL:FUNCTION MATCH-PATTERN-ELEMENT) NULL)
    (DEFINE-FUNCTION-OBJECT "MATCH-PATTERN"
     "(DEFUN (MATCH-PATTERN CONS) ((PATTERN CONS) (DATUM CONS) (DATUM-LENGTH INTEGER)))"
     (CL:FUNCTION MATCH-PATTERN) NULL)
    (DEFINE-FUNCTION-OBJECT "DEAL-WITH-NOON-MIDN"
     "(DEFUN DEAL-WITH-NOON-MIDN ((FORM-VALUE OBJECT) (PARSED-VALUES DECODED-DATE-TIME)))"
     (CL:FUNCTION DEAL-WITH-NOON-MIDN) NULL)
    (DEFINE-FUNCTION-OBJECT "DEAL-WITH-AM-PM"
     "(DEFUN DEAL-WITH-AM-PM ((FORM-VALUE OBJECT) (PARSED-VALUES DECODED-DATE-TIME)))"
     (CL:FUNCTION DEAL-WITH-AM-PM) NULL)
    (DEFINE-FUNCTION-OBJECT "SET-TIME-VALUES"
     "(DEFUN SET-TIME-VALUES ((STRING-FORM (CONS OF CONS)) (PARSED-VALUES DECODED-DATE-TIME)))"
     (CL:FUNCTION SET-TIME-VALUES) NULL)
    (DEFINE-FUNCTION-OBJECT "PARSE-DATE-TIME"
     "(DEFUN (PARSE-DATE-TIME DECODED-DATE-TIME) ((DATE-TIME-STRING STRING) (START INTEGER) (END INTEGER) (ERROR-ON-MISMATCH? BOOLEAN)) :PUBLIC? TRUE :DOCUMENTATION \"Tries very hard to make sense out of the argument `date-time-string' and
returns a time structure if successful.  If not, it returns `null'.
If `error-on-mismatch?' is true, parse-date-time will signal an error instead of
returning `null'.  
Default values are 00:00:00 UTC on the current date\")"
     (CL:FUNCTION PARSE-DATE-TIME) NULL)
    (DEFINE-FUNCTION-OBJECT "STRING-TO-CALENDAR-DATE"
     "(DEFUN (STRING-TO-CALENDAR-DATE CALENDAR-DATE) ((INPUT STRING)) :PUBLIC? TRUE :DOCUMENTATION \"Returns a calendar date object representing the date and time
parsed from the `input' string.  If no valid parse is found,
`null' is returned.\")" (CL:FUNCTION STRING-TO-CALENDAR-DATE) NULL)
    (DEFINE-FUNCTION-OBJECT "STARTUP-DATE-TIME-PARSER"
     "(DEFUN STARTUP-DATE-TIME-PARSER () :PUBLIC? TRUE)"
     (CL:FUNCTION STARTUP-DATE-TIME-PARSER) NULL)
    (CL:LET*
     ((FUNCTION
       (LOOKUP-FUNCTION SYM-DATE-TIME-PARSER-STELLA-STARTUP-DATE-TIME-PARSER)))
     (SET-DYNAMIC-SLOT-VALUE (%DYNAMIC-SLOTS FUNCTION)
      SYM-DATE-TIME-PARSER-STELLA-METHOD-STARTUP-CLASSNAME
      (WRAP-STRING "Startup-Date-Time-Parser") NULL-STRING-WRAPPER)))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 8) (FINALIZE-SLOTS)
    (CLEANUP-UNFINALIZED-CLASSES))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 9)
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFCONSTANT WHITESPACE-CHARS CONS (QUOTE (#\\  #\\Tab #\\Linefeed #\\, #\\' #\\`)))")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFCONSTANT TIME-DIVIDERS CONS (QUOTE (#\\: #\\.)))")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFCONSTANT DATE-DIVIDERS CONS (QUOTE (#\\\\ #\\/ #\\-)))")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFSPECIAL *ERROR-ON-MISMATCH* BOOLEAN FALSE :PUBLIC? TRUE :DOCUMENTATION \"If TRUE, an error will be signalled if parse-date-time is unable
   to determine the time/date format of the string.\")")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFSPECIAL *WEEKDAY-STRINGS* (STRING-HASH-TABLE OF STRING KEYWORD) (NEW (STRING-HASH-TABLE OF STRING KEYWORD)))")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFSPECIAL *MONTH-STRINGS* STRING-TO-INTEGER-HASH-TABLE (NEW STRING-TO-INTEGER-HASH-TABLE))")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFSPECIAL *ZONE-STRINGS* (STRING-HASH-TABLE OF STRING FLOAT-WRAPPER) (NEW (STRING-HASH-TABLE OF STRING FLOAT-WRAPPER)))")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFSPECIAL *SPECIAL-STRINGS* STRING-HASH-TABLE (NEW STRING-HASH-TABLE))")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFSPECIAL *SPECIAL-SYMBOLS* (CONS OF SYMBOL) (QUOTE (YESTERDAY TODAY TOMORROW NOW)))")
    (DEFINE-STELLA-GLOBAL-VARIABLE-FROM-STRINGIFIED-SOURCE
     "(DEFSPECIAL *DATE-TIME-PATTERNS* CONS (QUOTE ((YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY (NOON-MIDN)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (NOON-MIDN) (DATE-DIVIDER) (ZONE)) (MONTH (DATE-DIVIDER) YEAR (NOON-MIDN) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (NOON-MIDN) (DATE-DIVIDER) (ZONE)) ((NOON-MIDN) (WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR) ((NOON-MIDN) (WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR) ((NOON-MIDN) (WEEKDAY) MONTH (DATE-DIVIDER) DAY) ((NOON-MIDN) YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY) ((NOON-MIDN) MONTH (DATE-DIVIDER) YEAR) ((NOON-MIDN) YEAR (DATE-DIVIDER) MONTH) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (NOON-MIDN (DATE-DIVIDER) (ZONE)) (HOUR (NOON-MIDN)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY NOON-MIDN (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY NOW) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) MONTH HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) (WEEKDAY) MONTH (DATE-DIVIDER) DAY) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) YEAR (DATE-DIVIDER) MONTH (DATE-DIVIDER) DAY) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) MONTH (DATE-DIVIDER) YEAR) (HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE) YEAR (DATE-DIVIDER) MONTH) (WEEKDAY MONTH DAY HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) SECONDP (AM-PM) (ZONE) YEAR) ((WEEKDAY) DAY (DATE-DIVIDER) MONTH (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) ((WEEKDAY) MONTH (DATE-DIVIDER) DAY (DATE-DIVIDER) YEAR HOUR (TIME-DIVIDER) MINUTE (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (YEAR (DATE-DIVIDER) (MONTH)) (MONTH (DATE-DIVIDER) (YEAR)) ((WEEKDAY) MONTH DAY HOUR TIME-DIVIDER MINUTE (TIME-DIVIDER) (SECONDP) YEAR) (NOW (YESTERDAY)) ((YESTERDAY) NOW) (NOW (TODAY)) ((TODAY) NOW) (NOW (TOMORROW)) ((TOMORROW) NOW) (YESTERDAY (NOON-MIDN)) ((NOON-MIDN) YESTERDAY) (TODAY (NOON-MIDN)) ((NOON-MIDN) TODAY) (TOMORROW (NOON-MIDN)) ((NOON-MIDN) TOMORROW) (YESTERDAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (TOMORROW HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)) (TODAY HOUR (TIME-DIVIDER) (MINUTE) (TIME-DIVIDER) (SECONDP) (AM-PM) (DATE-DIVIDER) (ZONE)))))")))
  :VOID)
